// Programmed by Taeho Oh
// Email : ohhara@postech.ac.kr

#include <iostream.h>
#include <gtk--.h>

class ColorSelectionDialog : public Gtk_Window
{
	Gtk_Button b1;
	Gtk_ColorSelectionDialog csd1;
public:
	ColorSelectionDialog() : b1( "Show Color Selection Dialog" ), csd1("Select Color")
	{
		add( &b1 );
		connect_to_method( b1.clicked, this, &show_colorselectiondialog );
		connect_to_method( csd1.ok_button.clicked, this, &ok_colorselectiondialog );
		connect_to_method( csd1.cancel_button.clicked, this, &cancel_colorselectiondialog );
		b1.show();
	}
	gint delete_event_impl( GdkEventAny* gdkeventany )
	{
		Gtk_Main::instance()->quit(); 
		return 0;
	}
	void show_colorselectiondialog()
	{
		csd1.show();
	}
	void ok_colorselectiondialog()
	{
		gdouble color[3];
		guint16 red,green,blue;
		csd1.colorsel.get_color(color);
		red=(guint16)(color[0]*65535.0);
		green=(guint16)(color[1]*65535.0);
		blue=(guint16)(color[2]*65535.0);
		cout << "OK" << endl;
		cout << "Red " << red << endl;
		cout << "Green " << green << endl;
		cout << "Blue " << blue << endl;
		cout <<endl;
		csd1.hide();
	}
	void cancel_colorselectiondialog()
	{
		gdouble color[3];
		guint16 red,green,blue;
		csd1.colorsel.get_color(color);
		red=(guint16)(color[0]*65535.0);
		green=(guint16)(color[1]*65535.0);
		blue=(guint16)(color[2]*65535.0);
		cout << "Cancel" << endl;
		cout << "Red " << red << endl;
		cout << "Green " << green << endl;
		cout << "Blue " << blue << endl;
		cout <<endl;
		csd1.hide();
	}
};


int main( int argc, char **argv )
{
	Gtk_Main m( &argc, &argv );
	ColorSelectionDialog w;

	w.set_usize( 200, 20 ); 
	w.show();

	m.run();
	return 0;
}
