// Programmed by Taeho Oh
// Email : ohhara@postech.ac.kr

#include <iostream.h>
#include <gtk--.h>

class Menu : public Gtk_Window
{
	Gtk_VBox vbox;
	Gtk_MenuBar menubar1;
	Gtk_Menu menu1, menu2, menu3;
	Gtk_MenuItem mi1, mi2, mi3;
	Gtk_MenuItem mi1_1, mi1_2, mi1_3;
	Gtk_Menu menu1_3;
	Gtk_MenuItem mi1_3_1, mi1_3_2;
	Gtk_CheckMenuItem cmi2_1, cmi2_2, cmi2_3;
	Gtk_RadioMenuItem rmi3_1, rmi3_2, rmi3_3;
public:
	Menu() : mi1( "Menu1" ), mi2( "Menu2" ), mi3( "Menu3" ),
		mi1_1( "Menu 1_1" ), mi1_2( "Menu 1_2" ), mi1_3( "Menu 1_3" ),
		mi1_3_1( "Menu 1_3_1" ), mi1_3_2( "Menu 1_3_2" ),
		cmi2_1( "Menu 2_1" ), cmi2_2( "Menu 2_2" ), cmi2_3( "Menu 2_3" ),
		rmi3_1( NULL, "Menu 3_1" ),
		rmi3_2( rmi3_1.group(), "Menu 3_2" ),
		rmi3_3( rmi3_2.group(), "Menu 3_3" )
	{
		add(&vbox);
		vbox.pack_start(&menubar1,false,false);
		menubar1.append( &mi1 );
		menubar1.append( &mi2 );
		menubar1.append( &mi3 );
		mi3.right_justify();
		mi1.set_submenu( &menu1 );
		mi2.set_submenu( &menu2 );
		mi3.set_submenu( &menu3 );
		menu1.append( &mi1_1 );
		menu1.append( &mi1_2 );
		menu1.append( &mi1_3 );
		mi1_3.set_submenu( &menu1_3 );
		menu1_3.append( &mi1_3_1 );
		menu1_3.append( &mi1_3_2 );
		menu2.append( &cmi2_1 );
		menu2.append( &cmi2_2 );
		menu2.append( &cmi2_3 );
		menu3.append( &rmi3_1 );
		menu3.append( &rmi3_2 );
		menu3.append( &rmi3_3 );

		cmi2_1.set_show_toggle(true);
		cmi2_2.set_show_toggle(true);
		cmi2_3.set_show_toggle(true);

		rmi3_1.set_show_toggle(true);
		rmi3_2.set_show_toggle(true);
		rmi3_3.set_show_toggle(true);

		connect_to_method( mi1_1.activate, this, &mi1_1_activate );
		connect_to_method( mi1_2.activate, this, &mi1_2_activate );
		connect_to_method( mi1_3.activate, this, &mi1_3_activate );
		connect_to_method( mi1_3_1.activate, this, &mi1_3_1_activate );
		connect_to_method( mi1_3_2.activate, this, &mi1_3_2_activate );

		connect_to_method( cmi2_1.toggled, this, &cmi2_1_toggled );
		connect_to_method( cmi2_2.toggled, this, &cmi2_2_toggled );
		connect_to_method( cmi2_3.toggled, this, &cmi2_3_toggled );

		connect_to_method( rmi3_1.toggled, this, &rmi3_1_toggled );
		connect_to_method( rmi3_2.toggled, this, &rmi3_2_toggled );
		connect_to_method( rmi3_3.toggled, this, &rmi3_3_toggled );

		vbox.show();
		menubar1.show();
		mi1.show();
		mi2.show();
		mi3.show();
		mi1_1.show();
		mi1_2.show();
		mi1_3.show();
		mi1_3_1.show();
		mi1_3_2.show();
		cmi2_1.show();
		cmi2_2.show();
		cmi2_3.show();
		rmi3_1.show();
		rmi3_2.show();
		rmi3_3.show();
	}
	gint delete_event_impl( GdkEventAny* gdkeventany )
	{
		Gtk_Main::instance()->quit(); 
		return 0;
	}
	void mi1_1_activate()
	{
		cout << "Menu 1_1 Activate" << endl;
	}
	void mi1_2_activate()
	{
		cout << "Menu 1_2 Activate" << endl;
	}
	void mi1_3_activate()
	{
		cout << "Menu 1_3 Activate" << endl;
	}
	void mi1_3_1_activate()
	{
		cout << "Menu 1_3_1 Activate" << endl;
	}
	void mi1_3_2_activate()
	{
		cout << "Menu 1_3_2 Activate" << endl;
	}
	void cmi2_1_toggled()
	{
		cout << "Menu 2_1 Toggled" << endl;
	}
	void cmi2_2_toggled()
	{
		cout << "Menu 2_2 Toggled" << endl;
	}
	void cmi2_3_toggled()
	{
		cout << "Menu 2_3 Toggled" << endl;
	}
	void rmi3_1_toggled()
	{
		cout << "Menu 3_1 Toggled" << endl;
	}
	void rmi3_2_toggled()
	{
		cout << "Menu 3_2 Toggled" << endl;
	}
	void rmi3_3_toggled()
	{
		cout << "Menu 3_3 Toggled" << endl;
	}
};


int main( int argc, char **argv )
{
	Gtk_Main m( &argc, &argv );
	Menu w;

	w.set_usize( 400, 50 ); 
	w.show();

	m.run();
	return 0;
}
